<template>
  <list-item class="group">
    <div class="top">
      <router-link :to="`/wyposazenie/${location.id}`">
        <font-awesome-icon :icon="icons.faToolbox" /> {{ item.name }}
      </router-link>
    </div>
    <div class="left">
      <span>Przekazane przez</span>
      <router-link v-if="from" :to="`/osoby/${from.id}`">
        <font-awesome-icon :icon="icons.faUser" /> {{ from.name }}
        {{ from.surname }}
      </router-link>
      <span v-else>
        <font-awesome-icon :icon="icons.faUserSlash" /> <b>nie podano</b>
      </span>
      <div>
        <font-awesome-icon :icon="icons.faCalendarAlt" /> {{ get_date() }}
      </div>
    </div>
    <div class="arrow">
      <font-awesome-icon :icon="icons.faArrowRight" />
    </div>
    <div class="right">
      <span>Do</span>
      <router-link v-if="to" :to="`/osoby/${to.id}`">
        <font-awesome-icon :icon="icons.faUser" /> {{ to.name }}
        {{ to.surname }}
      </router-link>
      <span v-else>
        <font-awesome-icon :icon="icons.faUserSlash" /> <b>nie podano</b>
      </span>
      <br />
      <router-link :to="`/lokalizacje/${location.id}`">
        <font-awesome-icon :icon="icons.faMapMarkerAlt" />
        {{ location.name }} ({{ location.type }})
      </router-link>
    </div>
    <div
      v-if="!isAction"
      :class="['link', { green: confirmed }, { red: !confirmed }]"
    >
      <font-awesome-icon :icon="confirmed ? icons.faCheck : icons.faTimes" />
      <tooltip>{{
        confirmed ? "Operacja potwierdzona" : "Operacja czeka na potwierdzenie"
      }}</tooltip>
    </div>
    <div v-else class="link" v-on:click="accept_action">Potwierdź</div>
  </list-item>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import ListItem from "@/components/list/ListItem.vue";
import Moment from "moment";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import {
  faArrowRight,
  faMapMarkerAlt,
  faUser,
  faToolbox,
  faCheck,
  faTimes,
  faUserSlash,
  faCalendarAlt,
} from "@fortawesome/free-solid-svg-icons";

import { ActionData, UserData, LocationData, ItemData } from "@/interfaces";
import Tooltip from "@/components/utilities/Tooltip.vue";
import { NApi } from "@/interfaces/connector";

@Options({
  props: {
    id: Number,
    from: Object,
    to: Object,
    location: Object,
    item: Object,
    description: String,
    confirmed: Boolean,
    creation_date: String,
    isAction: {
      type: Boolean,
      default: false,
    },
  },
  components: {
    ListItem,
    FontAwesomeIcon,
    Tooltip,
  },
  emits: ["model-reload"],
})
export default class ActionListItem extends Vue implements ActionData {
  public id!: number;
  public from?: UserData;
  public to?: UserData;
  public location!: LocationData;
  public item!: ItemData;
  public description!: string;
  public confirmed!: boolean;
  public creation_date!: Date;

  public months = [
    "stycznia",
    "lutego",
    "marca",
    "kwietnia",
    "maja",
    "czerwca",
    "lipca",
    "sierpnia",
    "września",
    "października",
    "listopada",
    "grudnia",
  ];

  public icons = {
    faArrowRight,
    faMapMarkerAlt,
    faUser,
    faToolbox,
    faCheck,
    faTimes,
    faUserSlash,
    faCalendarAlt,
  };

  public async accept_action(): Promise<void> {
    try {
      await NApi.acceptAction({ id: this.id });
    } catch (e) {
      console.error(e);
    }

    this.$emit("model-reload");
  }

  public get_date(): string {
    const date: Moment.Moment = Moment(this.creation_date);

    return `${date.day() + 1} ${this.months[date.month()]} ${date.year()}`;
  }
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";

@include bit-smaller-icon;

.group {
  display: grid;
  grid-template-columns: 1fr auto 1fr auto;
  grid-template-rows: auto auto;

  grid-template-areas:
    "top top top link"
    "left arrow right link";

  .top,
  .left,
  .right {
    text-align: left;
    color: $black_text;
    font-size: 14px;

    line-height: 22px;

    a {
      text-decoration: none;
      color: $black_text;
    }

    span {
      font-weight: bold;
      display: block;
    }
  }
  .top {
    grid-area: top;
    font-weight: bold;
    padding-bottom: $small_margin;
  }

  .left {
    grid-area: left;

    text-align: left;
    color: $black_text;
  }

  .right {
    grid-area: right;

    text-align: left;
    color: $black_text;
  }

  .link {
    grid-area: link;
    text-decoration: none;
    color: $dark_blue;
    cursor: pointer;
    font-size: 16px;
    font-weight: bold;

    align-self: center;
    position: relative;

    &.red {
      color: $red;
    }
    &.green {
      color: $green;
    }
  }

  .arrow {
    grid-area: arrow;
    align-self: center;

    padding: $small_margin;

    .svg-inline--fa {
      font-size: 18px;
    }
  }
}
</style>
